/* crypt (mkpasswd) script by dave
 * part of the updated cryptography functions for server/oper passwords
 * 4/20/2002
 */

#include <stdio.h>
#include <stdlib.h>
#include <crypt.h>
#include <unistd.h>

int main(int argc, char **argv)
{
	static char salts[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
	char salt[3], *plain;

	if(argc < 2)
	{
		srandom(time(0));
		salt[0] = salts[random() % 64];
		salt[1] = salts[random() % 64];
		salt[2] = '\0';
	}
	else
	{
		if ((strchr(salts, salt[0]) != 0) || (strchr(salts, salt[1]) != 0))
		{
			printf("crypt: invalid salt: %s\n", argv[1]);
			exit(1);
		}
		salt[0] = argv[1][0];
		salt[1] = argv[1][1];
		salt[2] = '\0';
	}

	printf("Salt: %s\n", salt);

	plain = getpass("Password: ");

	printf("Encrypted: %s\n", crypt(plain, salt));

	return 0;
}
